Added libipsec/net2net-3des scenario
[strongswan.git] / testing / tests / libipsec / net2net-3des / hosts / moon / etc / updown
1 #! /bin/sh
2 # iproute2 version, default updown script
3 #
4 # Copyright (C) 2003-2004 Nigel Meteringham
5 # Copyright (C) 2003-2004 Tuomo Soini
6 # Copyright (C) 2002-2004 Michael Richardson
7 # Copyright (C) 2005-2007 Andreas Steffen <andreas.steffen@strongswan.org>
8 #
9 # This program is free software; you can redistribute it and/or modify it
10 # under the terms of the GNU General Public License as published by the
11 # Free Software Foundation; either version 2 of the License, or (at your
12 # option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
13 #
14 # This program is distributed in the hope that it will be useful, but
15 # WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
16 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
17 # for more details.
18
19 # CAUTION:  Installing a new version of strongSwan will install a new
20 # copy of this script, wiping out any custom changes you make.  If
21 # you need changes, make a copy of this under another name, and customize
22 # that, and use the (left/right)updown parameters in ipsec.conf to make
23 # strongSwan use yours instead of this default one.
24
25 # things that this script gets (from ipsec_pluto(8) man page)
26 #
27 #      PLUTO_VERSION
28 #              indicates  what  version of this interface is being
29 #              used.  This document describes version  1.1.   This
30 #              is upwardly compatible with version 1.0.
31 #
32 #       PLUTO_VERB
33 #              specifies the name of the operation to be performed
34 #              (prepare-host, prepare-client, up-host, up-client,
35 #              down-host, or down-client).  If the address family
36 #              for security gateway to security gateway communica-
37 #              tions is IPv6, then a suffix of -v6 is added to the
38 #              verb.
39 #
40 #       PLUTO_CONNECTION
41 #              is the name of the  connection  for  which  we  are
42 #              routing.
43 #
44 #       PLUTO_NEXT_HOP
45 #              is the next hop to which packets bound for the peer
46 #              must be sent.
47 #
48 #       PLUTO_INTERFACE
49 #              is the name of the ipsec interface to be used.
50 #
51 #       PLUTO_REQID
52 #              is the requid of the ESP policy
53 #
54 #       PLUTO_UNIQUEID
55 #              is the unique identifier of the associated IKE_SA
56 #
57 #       PLUTO_ME
58 #              is the IP address of our host.
59 #
60 #       PLUTO_MY_ID
61 #              is the ID of our host.
62 #
63 #       PLUTO_MY_CLIENT
64 #              is the IP address / count of our client subnet.  If
65 #              the  client  is  just  the  host,  this will be the
66 #              host's own IP address / max (where max  is  32  for
67 #              IPv4 and 128 for IPv6).
68 #
69 #       PLUTO_MY_CLIENT_NET
70 #              is the IP address of our client net.  If the client
71 #              is just the host, this will be the  host's  own  IP
72 #              address.
73 #
74 #       PLUTO_MY_CLIENT_MASK
75 #              is  the  mask for our client net.  If the client is
76 #              just the host, this will be 255.255.255.255.
77 #
78 #       PLUTO_MY_SOURCEIP
79 #       PLUTO_MY_SOURCEIP4_$i
80 #       PLUTO_MY_SOURCEIP6_$i
81 #              contains IPv4/IPv6 virtual IP received from a responder,
82 #              $i enumerates from 1 to the number of IP per address family.
83 #              PLUTO_MY_SOURCEIP is a legacy variable and equals to the first
84 #              virtual IP, IPv4 or IPv6.
85 #
86 #       PLUTO_MY_PROTOCOL
87 #              is the IP protocol that will be transported.
88 #
89 #       PLUTO_MY_PORT
90 #              is  the  UDP/TCP  port  to  which  the IPsec SA  is
91 #              restricted on our side.
92 #
93 #       PLUTO_PEER
94 #              is the IP address of our peer.
95 #
96 #       PLUTO_PEER_ID
97 #              is the ID of our peer.
98 #
99 #       PLUTO_PEER_CA
100 #              is the CA which issued the cert of our peer.
101 #
102 #       PLUTO_PEER_CLIENT
103 #              is the IP address / count of the peer's client sub-
104 #              net.   If the client is just the peer, this will be
105 #              the peer's own IP address / max (where  max  is  32
106 #              for IPv4 and 128 for IPv6).
107 #
108 #       PLUTO_PEER_CLIENT_NET
109 #              is the IP address of the peer's client net.  If the
110 #              client is just the peer, this will  be  the  peer's
111 #              own IP address.
112 #
113 #       PLUTO_PEER_CLIENT_MASK
114 #              is  the  mask  for  the  peer's client net.  If the
115 #              client   is   just   the   peer,   this   will   be
116 #              255.255.255.255.
117 #
118 #       PLUTO_PEER_PROTOCOL
119 #              is the IP protocol that will be transported.
120 #
121 #       PLUTO_PEER_PORT
122 #              is  the  UDP/TCP  port  to  which  the IPsec SA  is
123 #              restricted on the peer side.
124 #
125 #       PLUTO_XAUTH_ID
126 #              is an optional user ID employed by the XAUTH protocol
127 #
128 #       PLUTO_MARK_IN
129 #              is an optional XFRM mark set on the inbound IPsec SA
130 #
131 #       PLUTO_MARK_OUT
132 #              is an optional XFRM mark set on the outbound IPsec SA
133 #
134 #       PLUTO_UDP_ENC
135 #              contains the remote UDP port in the case of ESP_IN_UDP
136 #              encapsulation
137 #
138 #       PLUTO_DNS4_$i
139 #       PLUTO_DNS6_$i
140 #              contains IPv4/IPv6 DNS server attribute received from a
141 #              responder, $i enumerates from 1 to the number of servers per
142 #              address family.
143 #
144
145 # define a minimum PATH environment in case it is not set
146 PATH="/sbin:/bin:/usr/sbin:/usr/bin:/usr/sbin"
147 export PATH
148
149 # uncomment to log VPN connections
150 VPN_LOGGING=1
151 #
152 # tag put in front of each log entry:
153 TAG=vpn
154 #
155 # syslog facility and priority used:
156 FAC_PRIO=local0.notice
157 #
158 # to create a special vpn logging file, put the following line into
159 # the syslog configuration file /etc/syslog.conf:
160 #
161 # local0.notice                   -/var/log/vpn
162
163 # in order to use source IP routing the Linux kernel options
164 # CONFIG_IP_ADVANCED_ROUTER and CONFIG_IP_MULTIPLE_TABLES
165 # must be enabled
166 #
167 # special routing table for sourceip routes
168 SOURCEIP_ROUTING_TABLE=220
169 #
170 # priority of the sourceip routing table
171 SOURCEIP_ROUTING_TABLE_PRIO=220
172
173 # check interface version
174 case "$PLUTO_VERSION" in
175 1.[0|1])        # Older Pluto?!?  Play it safe, script may be using new features.
176         echo "$0: obsolete interface version \`$PLUTO_VERSION'," >&2
177         echo "$0:       called by obsolete Pluto?" >&2
178         exit 2
179         ;;
180 1.*)    ;;
181 *)      echo "$0: unknown interface version \`$PLUTO_VERSION'" >&2
182         exit 2
183         ;;
184 esac
185
186 # check parameter(s)
187 case "$1:$*" in
188 ':')                    # no parameters
189         ;;
190 iptables:iptables)      # due to (left/right)firewall; for default script only
191         ;;
192 custom:*)               # custom parameters (see above CAUTION comment)
193         ;;
194 *)      echo "$0: unknown parameters \`$*'" >&2
195         exit 2
196         ;;
197 esac
198
199 # utility functions for route manipulation
200 # Meddling with this stuff should not be necessary and requires great care.
201 uproute() {
202         doroute add
203         ip route flush cache
204 }
205 downroute() {
206         doroute delete
207         ip route flush cache
208 }
209
210 addsource() {
211         st=0
212         if ! ip -o route get ${PLUTO_MY_SOURCEIP%/*} | grep -q ^local
213         then
214             it="ip addr add ${PLUTO_MY_SOURCEIP%/*}/32 dev $PLUTO_INTERFACE"
215             oops="`eval $it 2>&1`"
216             st=$?
217             if test " $oops" = " " -a " $st" != " 0"
218             then
219                 oops="silent error, exit status $st"
220             fi
221             if test " $oops" != " " -o " $st" != " 0"
222             then
223                 echo "$0: addsource \`$it' failed ($oops)" >&2
224             fi
225         fi
226         return $st
227 }
228
229 doroute() {
230         st=0
231
232         if [ -z "$PLUTO_MY_SOURCEIP" ]
233         then
234             for dir in /etc/sysconfig /etc/conf.d; do
235                 if [ -f "$dir/defaultsource" ]
236                 then
237                     . "$dir/defaultsource"
238                 fi
239             done
240
241             if [ -n "$DEFAULTSOURCE" ]
242             then
243                 PLUTO_MY_SOURCEIP=$DEFAULTSOURCE
244             fi
245         fi
246
247         if [ -z "$KLIPS" -a -z "$PLUTO_MY_SOURCEIP" ]
248         then
249             # leave because no route entry is required
250             return $st
251         fi
252
253         parms1="$PLUTO_PEER_CLIENT"
254
255         if [ -n "$PLUTO_NEXT_HOP" ]
256         then
257             parms2="via $PLUTO_NEXT_HOP"
258         else
259             parms2="via $PLUTO_PEER"
260         fi
261         parms2="$parms2 dev $PLUTO_INTERFACE"
262
263         parms3=
264         if [ -n "$PLUTO_MY_SOURCEIP" ]
265         then
266             if test "$1" = "add"
267             then
268                 addsource
269                 if ! ip rule list | grep -q "lookup $SOURCEIP_ROUTING_TABLE"
270                 then
271                     ip rule add pref $SOURCEIP_ROUTING_TABLE_PRIO table $SOURCEIP_ROUTING_TABLE
272                 fi
273             fi
274             parms3="$parms3 src ${PLUTO_MY_SOURCEIP%/*} table $SOURCEIP_ROUTING_TABLE"
275         fi
276
277         case "$PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK" in
278         "0.0.0.0/0.0.0.0")
279                 # opportunistic encryption work around
280                 # need to provide route that eclipses default, without
281                 # replacing it.
282                 it="ip route $1 0.0.0.0/1 $parms2 $parms3 &&
283                         ip route $1 128.0.0.0/1 $parms2 $parms3"
284                 ;;
285         *)      it="ip route $1 $parms1 $parms2 $parms3"
286                 ;;
287         esac
288         oops="`eval $it 2>&1`"
289         st=$?
290         if test " $oops" = " " -a " $st" != " 0"
291         then
292             oops="silent error, exit status $st"
293         fi
294         if test " $oops" != " " -o " $st" != " 0"
295         then
296             echo "$0: doroute \`$it' failed ($oops)" >&2
297         fi
298         return $st
299 }
300
301 # in the presence of KLIPS and ipsecN interfaces do not use IPSEC_POLICY
302 if [ `echo "$PLUTO_INTERFACE" | grep "ipsec"` ]
303 then
304         KLIPS=1
305         IPSEC_POLICY_IN=""
306         IPSEC_POLICY_OUT=""
307 else
308         KLIPS=
309         IPSEC_POLICY="-m policy --pol ipsec --proto esp --reqid $PLUTO_REQID"
310         IPSEC_POLICY_IN="$IPSEC_POLICY --dir in"
311         IPSEC_POLICY_OUT="$IPSEC_POLICY --dir out"
312 fi
313
314 # are there port numbers?
315 if [ "$PLUTO_MY_PORT" != 0 ]
316 then
317         S_MY_PORT="--sport $PLUTO_MY_PORT"
318         D_MY_PORT="--dport $PLUTO_MY_PORT"
319 fi
320 if [ "$PLUTO_PEER_PORT" != 0 ]
321 then
322         S_PEER_PORT="--sport $PLUTO_PEER_PORT"
323         D_PEER_PORT="--dport $PLUTO_PEER_PORT"
324 fi
325
326 # resolve octal escape sequences
327 PLUTO_MY_ID=`printf "$PLUTO_MY_ID"`
328 PLUTO_PEER_ID=`printf "$PLUTO_PEER_ID"`
329
330 # the big choice
331 case "$PLUTO_VERB:$1" in
332 prepare-host:*|prepare-client:*)
333         if [ -z "$KLIPS" -a -z "$PLUTO_MY_SOURCEIP" ]
334         then
335             # exit because no route will be added,
336             # so that existing routes can stay
337             exit 0
338         fi
339
340         # delete possibly-existing route (preliminary to adding a route)
341         case "$PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK" in
342         "0.0.0.0/0.0.0.0")
343                 # need to provide route that eclipses default, without
344                 # replacing it.
345                 parms1="0.0.0.0/1"
346                 parms2="128.0.0.0/1"
347                 it="ip route delete $parms1 2>&1 ; ip route delete $parms2 2>&1"
348                 oops="`ip route delete $parms1 2>&1 ; ip route delete $parms2 2>&1`"
349                 ;;
350         *)
351                 parms="$PLUTO_PEER_CLIENT"
352                 it="ip route delete $parms 2>&1"
353                 oops="`ip route delete $parms 2>&1`"
354                 ;;
355         esac
356         status="$?"
357         if test " $oops" = " " -a " $status" != " 0"
358         then
359                 oops="silent error, exit status $status"
360         fi
361         case "$oops" in
362         *'RTNETLINK answers: No such process'*)
363                 # This is what route (currently -- not documented!) gives
364                 # for "could not find such a route".
365                 oops=
366                 status=0
367                 ;;
368         esac
369         if test " $oops" != " " -o " $status" != " 0"
370         then
371                 echo "$0: \`$it' failed ($oops)" >&2
372         fi
373         exit $status
374         ;;
375 route-host:*|route-client:*)
376         # connection to me or my client subnet being routed
377         uproute
378         ;;
379 unroute-host:*|unroute-client:*)
380         # connection to me or my client subnet being unrouted
381         downroute
382         ;;
383 up-host:)
384         # connection to me coming up
385         # If you are doing a custom version, firewall commands go here.
386         ;;
387 down-host:)
388         # connection to me going down
389         # If you are doing a custom version, firewall commands go here.
390         ;;
391 up-client:)
392         # connection to my client subnet coming up
393         # If you are doing a custom version, firewall commands go here.
394         PLUTO_INTERFACE=ipsec0
395         iptables -I FORWARD 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
396             -s $PLUTO_MY_CLIENT $S_MY_PORT \
397             -d $PLUTO_PEER_CLIENT $D_PEER_PORT -j ACCEPT
398         iptables -I FORWARD 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
399             -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
400             -d $PLUTO_MY_CLIENT $D_MY_PORT -j ACCEPT
401         ;;
402 down-client:)
403         # connection to my client subnet going down
404         # If you are doing a custom version, firewall commands go here.
405         PLUTO_INTERFACE=ipsec0
406         iptables -D FORWARD -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
407             -s $PLUTO_MY_CLIENT $S_MY_PORT \
408             -d $PLUTO_PEER_CLIENT $D_PEER_PORT -j ACCEPT
409         iptables -D FORWARD -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
410             -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
411             -d $PLUTO_MY_CLIENT $D_MY_PORT -j ACCEPT
412         ;;
413 up-host:iptables)
414         # connection to me, with (left/right)firewall=yes, coming up
415         # This is used only by the default updown script, not by your custom
416         # ones, so do not mess with it; see CAUTION comment up at top.
417         iptables -I INPUT 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
418             -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
419             -d $PLUTO_ME $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
420         iptables -I OUTPUT 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
421             -s $PLUTO_ME $S_MY_PORT $IPSEC_POLICY_OUT \
422             -d $PLUTO_PEER_CLIENT $D_PEER_PORT -j ACCEPT
423         #
424         # log IPsec host connection setup
425         if [ $VPN_LOGGING ]
426         then
427           if [ "$PLUTO_PEER_CLIENT" = "$PLUTO_PEER/32" ]
428           then
429             logger -t $TAG -p $FAC_PRIO \
430               "+ $PLUTO_PEER_ID $PLUTO_PEER -- $PLUTO_ME"
431           else
432             logger -t $TAG -p $FAC_PRIO \
433               "+ $PLUTO_PEER_ID $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME"
434           fi
435         fi
436         ;;
437 down-host:iptables)
438         # connection to me, with (left/right)firewall=yes, going down
439         # This is used only by the default updown script, not by your custom
440         # ones, so do not mess with it; see CAUTION comment up at top.
441         iptables -D INPUT -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
442             -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
443             -d $PLUTO_ME $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
444         iptables -D OUTPUT -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
445             -s $PLUTO_ME $S_MY_PORT $IPSEC_POLICY_OUT \
446             -d $PLUTO_PEER_CLIENT $D_PEER_PORT -j ACCEPT
447         #
448         # log IPsec host connection teardown
449         if [ $VPN_LOGGING ]
450         then
451           if [ "$PLUTO_PEER_CLIENT" = "$PLUTO_PEER/32" ]
452           then
453             logger -t $TAG -p $FAC_PRIO -- \
454               "- $PLUTO_PEER_ID $PLUTO_PEER -- $PLUTO_ME"
455           else
456             logger -t $TAG -p $FAC_PRIO -- \
457             "- $PLUTO_PEER_ID $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME"
458           fi
459         fi
460         ;;
461 up-client:iptables)
462         # connection to client subnet, with (left/right)firewall=yes, coming up
463         # This is used only by the default updown script, not by your custom
464         # ones, so do not mess with it; see CAUTION comment up at top.
465         if [ "$PLUTO_PEER_CLIENT" != "$PLUTO_MY_SOURCEIP/32" ]
466         then
467           iptables -I FORWARD 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
468               -s $PLUTO_MY_CLIENT $S_MY_PORT \
469               -d $PLUTO_PEER_CLIENT $D_PEER_PORT $IPSEC_POLICY_OUT -j ACCEPT
470           iptables -I FORWARD 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
471               -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
472               -d $PLUTO_MY_CLIENT $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
473         fi
474         #
475         # a virtual IP requires an INPUT and OUTPUT rule on the host
476         # or sometimes host access via the internal IP is needed
477         if [ -n "$PLUTO_MY_SOURCEIP" -o -n "$PLUTO_HOST_ACCESS" ]
478         then
479           iptables -I INPUT 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
480               -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
481               -d $PLUTO_MY_CLIENT $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
482           iptables -I OUTPUT 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
483               -s $PLUTO_MY_CLIENT $S_MY_PORT \
484               -d $PLUTO_PEER_CLIENT $D_PEER_PORT $IPSEC_POLICY_OUT -j ACCEPT
485         fi
486         #
487         # log IPsec client connection setup
488         if [ $VPN_LOGGING ]
489         then
490           if [ "$PLUTO_PEER_CLIENT" = "$PLUTO_PEER/32" ]
491           then
492             logger -t $TAG -p $FAC_PRIO \
493               "+ $PLUTO_PEER_ID $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
494           else
495             logger -t $TAG -p $FAC_PRIO \
496               "+ $PLUTO_PEER_ID $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
497           fi
498         fi
499         ;;
500 down-client:iptables)
501         # connection to client subnet, with (left/right)firewall=yes, going down
502         # This is used only by the default updown script, not by your custom
503         # ones, so do not mess with it; see CAUTION comment up at top.
504         if [ "$PLUTO_PEER_CLIENT" != "$PLUTO_MY_SOURCEIP/32" ]
505         then
506           iptables -D FORWARD -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
507               -s $PLUTO_MY_CLIENT $S_MY_PORT \
508               -d $PLUTO_PEER_CLIENT $D_PEER_PORT \
509                  $IPSEC_POLICY_OUT -j ACCEPT
510           iptables -D FORWARD -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
511               -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
512               -d $PLUTO_MY_CLIENT $D_MY_PORT \
513                  $IPSEC_POLICY_IN -j ACCEPT
514         fi
515         #
516         # a virtual IP requires an INPUT and OUTPUT rule on the host
517         # or sometimes host access via the internal IP is needed
518         if [ -n "$PLUTO_MY_SOURCEIP" -o -n "$PLUTO_HOST_ACCESS" ]
519         then
520           iptables -D INPUT -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
521               -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
522               -d $PLUTO_MY_CLIENT $D_MY_PORT \
523                  $IPSEC_POLICY_IN -j ACCEPT
524           iptables -D OUTPUT -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
525               -s $PLUTO_MY_CLIENT $S_MY_PORT \
526               -d $PLUTO_PEER_CLIENT $D_PEER_PORT \
527                  $IPSEC_POLICY_OUT -j ACCEPT
528         fi
529         #
530         # log IPsec client connection teardown
531         if [ $VPN_LOGGING ]
532         then
533           if [ "$PLUTO_PEER_CLIENT" = "$PLUTO_PEER/32" ]
534           then
535             logger -t $TAG -p $FAC_PRIO -- \
536               "- $PLUTO_PEER_ID $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
537           else
538             logger -t $TAG -p $FAC_PRIO -- \
539               "- $PLUTO_PEER_ID $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
540           fi
541         fi
542         ;;
543 #
544 # IPv6
545 #
546 prepare-host-v6:*|prepare-client-v6:*)
547         ;;
548 route-host-v6:*|route-client-v6:*)
549         # connection to me or my client subnet being routed
550         #uproute_v6
551         ;;
552 unroute-host-v6:*|unroute-client-v6:*)
553         # connection to me or my client subnet being unrouted
554         #downroute_v6
555         ;;
556 up-host-v6:)
557         # connection to me coming up
558         # If you are doing a custom version, firewall commands go here.
559         ;;
560 down-host-v6:)
561         # connection to me going down
562         # If you are doing a custom version, firewall commands go here.
563         ;;
564 up-client-v6:)
565         # connection to my client subnet coming up
566         # If you are doing a custom version, firewall commands go here.
567         ;;
568 down-client-v6:)
569         # connection to my client subnet going down
570         # If you are doing a custom version, firewall commands go here.
571         ;;
572 up-host-v6:iptables)
573         # connection to me, with (left/right)firewall=yes, coming up
574         # This is used only by the default updown script, not by your custom
575         # ones, so do not mess with it; see CAUTION comment up at top.
576         ip6tables -I INPUT 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
577             -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
578             -d $PLUTO_ME $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
579         ip6tables -I OUTPUT 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
580             -s $PLUTO_ME $S_MY_PORT $IPSEC_POLICY_OUT \
581             -d $PLUTO_PEER_CLIENT $D_PEER_PORT -j ACCEPT
582         #
583         # log IPsec host connection setup
584         if [ $VPN_LOGGING ]
585         then
586           if [ "$PLUTO_PEER_CLIENT" = "$PLUTO_PEER/128" ]
587           then
588             logger -t $TAG -p $FAC_PRIO \
589               "+ $PLUTO_PEER_ID $PLUTO_PEER -- $PLUTO_ME"
590           else
591             logger -t $TAG -p $FAC_PRIO \
592               "+ $PLUTO_PEER_ID $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME"
593           fi
594         fi
595         ;;
596 down-host-v6:iptables)
597         # connection to me, with (left/right)firewall=yes, going down
598         # This is used only by the default updown script, not by your custom
599         # ones, so do not mess with it; see CAUTION comment up at top.
600         ip6tables -D INPUT -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
601             -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
602             -d $PLUTO_ME $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
603         ip6tables -D OUTPUT -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
604             -s $PLUTO_ME $S_MY_PORT $IPSEC_POLICY_OUT \
605             -d $PLUTO_PEER_CLIENT $D_PEER_PORT -j ACCEPT
606         #
607         # log IPsec host connection teardown
608         if [ $VPN_LOGGING ]
609         then
610           if [ "$PLUTO_PEER_CLIENT" = "$PLUTO_PEER/128" ]
611           then
612             logger -t $TAG -p $FAC_PRIO -- \
613               "- $PLUTO_PEER_ID $PLUTO_PEER -- $PLUTO_ME"
614           else
615             logger -t $TAG -p $FAC_PRIO -- \
616             "- $PLUTO_PEER_ID $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME"
617           fi
618         fi
619         ;;
620 up-client-v6:iptables)
621         # connection to client subnet, with (left/right)firewall=yes, coming up
622         # This is used only by the default updown script, not by your custom
623         # ones, so do not mess with it; see CAUTION comment up at top.
624         if [ "$PLUTO_PEER_CLIENT" != "$PLUTO_MY_SOURCEIP/128" ]
625         then
626           ip6tables -I FORWARD 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
627               -s $PLUTO_MY_CLIENT $S_MY_PORT \
628               -d $PLUTO_PEER_CLIENT $D_PEER_PORT $IPSEC_POLICY_OUT -j ACCEPT
629           ip6tables -I FORWARD 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
630               -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
631               -d $PLUTO_MY_CLIENT $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
632         fi
633         #
634         # a virtual IP requires an INPUT and OUTPUT rule on the host
635         # or sometimes host access via the internal IP is needed
636         if [ -n "$PLUTO_MY_SOURCEIP" -o -n "$PLUTO_HOST_ACCESS" ]
637         then
638           ip6tables -I INPUT 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
639               -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
640               -d $PLUTO_MY_CLIENT $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
641           ip6tables -I OUTPUT 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
642               -s $PLUTO_MY_CLIENT $S_MY_PORT \
643               -d $PLUTO_PEER_CLIENT $D_PEER_PORT $IPSEC_POLICY_OUT -j ACCEPT
644         fi
645         #
646         # log IPsec client connection setup
647         if [ $VPN_LOGGING ]
648         then
649           if [ "$PLUTO_PEER_CLIENT" = "$PLUTO_PEER/128" ]
650           then
651             logger -t $TAG -p $FAC_PRIO \
652               "+ $PLUTO_PEER_ID $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
653           else
654             logger -t $TAG -p $FAC_PRIO \
655               "+ $PLUTO_PEER_ID $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
656           fi
657         fi
658         ;;
659 down-client-v6:iptables)
660         # connection to client subnet, with (left/right)firewall=yes, going down
661         # This is used only by the default updown script, not by your custom
662         # ones, so do not mess with it; see CAUTION comment up at top.
663         if [ "$PLUTO_PEER_CLIENT" != "$PLUTO_MY_SOURCEIP/128" ]
664         then
665           ip6tables -D FORWARD -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
666               -s $PLUTO_MY_CLIENT $S_MY_PORT \
667               -d $PLUTO_PEER_CLIENT $D_PEER_PORT \
668                  $IPSEC_POLICY_OUT -j ACCEPT
669           ip6tables -D FORWARD -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
670               -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
671               -d $PLUTO_MY_CLIENT $D_MY_PORT \
672                  $IPSEC_POLICY_IN -j ACCEPT
673         fi
674         #
675         # a virtual IP requires an INPUT and OUTPUT rule on the host
676         # or sometimes host access via the internal IP is needed
677         if [ -n "$PLUTO_MY_SOURCEIP" -o -n "$PLUTO_HOST_ACCESS" ]
678         then
679           ip6tables -D INPUT -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
680               -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
681               -d $PLUTO_MY_CLIENT $D_MY_PORT \
682                  $IPSEC_POLICY_IN -j ACCEPT
683           ip6tables -D OUTPUT -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
684               -s $PLUTO_MY_CLIENT $S_MY_PORT \
685               -d $PLUTO_PEER_CLIENT $D_PEER_PORT \
686                  $IPSEC_POLICY_OUT -j ACCEPT
687         fi
688         #
689         # log IPsec client connection teardown
690         if [ $VPN_LOGGING ]
691         then
692           if [ "$PLUTO_PEER_CLIENT" = "$PLUTO_PEER/128" ]
693           then
694             logger -t $TAG -p $FAC_PRIO -- \
695               "- $PLUTO_PEER_ID $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
696           else
697             logger -t $TAG -p $FAC_PRIO -- \
698               "- $PLUTO_PEER_ID $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
699           fi
700         fi
701         ;;
702 *)      echo "$0: unknown verb \`$PLUTO_VERB' or parameter \`$1'" >&2
703         exit 1
704         ;;
705 esac